<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="640">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="150px"
    >
      <el-form-item label="父级" prop="parentTypeId" v-if="formData.parentTypeId !== 0">
        <el-tree-select
          v-model="formData.parentTypeId"
          :data="typeOptions"
          :props="{ value: 'id', label: 'locksetTypeName', children: 'children' }"
          placeholder="选择父级"
        />
      </el-form-item>

      <!--      <el-row>-->
      <!--        <el-col :span="19">-->
      <!--          <el-form-item label="锁具机构类型编码" prop="locksetTypeCode">-->
      <!--            <el-input-->
      <!--              v-model="formData.locksetTypeCode"-->
      <!--              placeholder="请输入锁具机构类型编码"-->
      <!--            />-->
      <!--          </el-form-item>-->
      <!--        </el-col>-->
      <!--        <el-col :span="3">-->
      <!--          <el-form-item label-width="80">-->
      <!--            <el-switch-->
      <!--              v-model="autoGenFlag"-->
      <!--              active-text="自动生成"-->
      <!--              @change="handleAutoGenChange"-->
      <!--            />-->
      <!--          </el-form-item>-->
      <!--        </el-col>-->
      <!--      </el-row>-->

      <el-form-item label="锁具机构类型名称" prop="locksetTypeName">
        <el-input v-model="formData.locksetTypeName" placeholder="请输入锁具机构类型名称" />
      </el-form-item>

      <el-form-item label="锁具机构类型图标" prop="locksetTypeIcon">
        <UploadImg :limit="1" v-model="formData.locksetTypeIcon" :fileSize="5" />
      </el-form-item>

      <el-form-item label="锁具机构类型图片" prop="locksetTypeImg">
        <UploadImg :limit="1" v-model="formData.locksetTypeImg" :fileSize="5" />
      </el-form-item>

      <el-form-item label="锁具机构类型规格" prop="locksetTypeSpec">
        <el-input v-model="formData.locksetTypeSpec" placeholder="请输入锁具机构类型规格" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import * as LockSetTypeApi from '@/api/hw/type/locksettype/index'
// import { genCode } from '@/api/system/autocode/rule'
import { handleTree } from '@/utils/tree'

defineOptions({ name: 'LockSetTypeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  locksetTypeId: undefined,
  parentTypeId: 0,
  locksetTypeName: '',
  locksetTypeCode: '',
  locksetTypeIcon: undefined,
  locksetTypeImg: undefined,
  locksetTypeSpec: undefined
})
const formRules = reactive({
  // locksetTypeCode: [{ required: true, message: '锁具机构类型编号不能为空', trigger: 'blur' }],
  locksetTypeName: [{ required: true, message: '锁具机构类型名称不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

// 类型树相关
const typeOptions = ref([])

// 自动生成编码
const autoGenFlag = ref(false)

/** 获取类型树 */
const getTypeTree = async () => {
  const res = await LockSetTypeApi.listLocksetType({
    pageNo: 1,
    pageSize: -1
  })
  typeOptions.value = handleTree(res.list, 'id', 'parentTypeId')
}

/** 打开弹窗 */
const open = async (type: string, id?: number, parentTypeId?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 设置父级ID
  if (parentTypeId) {
    formData.value.parentTypeId = parentTypeId
  }
  await getTypeTree()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await LockSetTypeApi.getLocksetTypeInfo(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await LockSetTypeApi.addLocksetType(data)
      message.success(t('common.createSuccess'))
    } else {
      await LockSetTypeApi.updateLocksetType(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 自动生成编码 */
// const handleAutoGenChange = async (val: boolean) => {
//   if (val) {
//     const res = await genCode('LOCKSET_TYPE_CODE')
//     formData.value.locksetTypeCode = res.data
//   } else {
//     formData.value.locksetTypeCode = ''
//   }
// }

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    locksetTypeId: undefined,
    parentTypeId: 0,
    locksetTypeName: '',
    locksetTypeCode: '',
    locksetTypeIcon: undefined,
    locksetTypeImg: undefined,
    locksetTypeSpec: undefined
  }
  formRef.value?.resetFields()
  autoGenFlag.value = false
}
</script>
